Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
[RISOLTO] Conflitto e2fsprogs
View unanswered posts
View posts from last 24 hours
View posts from last 7 days

Goto page Previous  1, 2, 3  
Reply to topic    Gentoo Forums Forum Index Forum italiano (Italian)
View previous topic :: View next topic  
Author Message
Peach
Advocate
Advocate


Joined: 08 Mar 2003
Posts: 3686
Location: London, UK

PostPosted: Sat Nov 15, 2008 2:39 pm    Post subject: Reply with quote

Peach wrote:
ho appena syncato e nel desiderio di fare un update generale mi sono chiaramente imbattuto in questo problema.
Noto però che c'è questa cosa interessante: con portage 2.2 se gli chiedo un update di world mi risponde alla fine con:
Code:
...
[ebuild  N    ] sys-libs/e2fsprogs-libs-1.41.2  USE="nls" 479 kB
[ebuild     U ] sys-fs/e2fsprogs-1.41.2 [1.40.9] USE="nls (-static%)" 4,263 kB
[blocks b     ] <sys-fs/e2fsprogs-1.41 ("<sys-fs/e2fsprogs-1.41" is blocking sys-libs/e2fsprogs-libs-1.41.2)
...
[uninstall    ] sys-libs/com_err-1.40.9  USE="nls"
[blocks b     ] sys-libs/com_err ("sys-libs/com_err" is blocking sys-libs/e2fsprogs-libs-1.41.2)
[uninstall    ] sys-libs/ss-1.40.9  USE="nls"
[blocks b     ] sys-libs/e2fsprogs-libs ("sys-libs/e2fsprogs-libs" is blocking sys-libs/ss-1.40.9, sys-libs/com_err-1.40.9)
[blocks b     ] sys-libs/ss ("sys-libs/ss" is blocking sys-libs/e2fsprogs-libs-1.41.2)


allora per sicurezza ho fetchato tutto prima di lanciare l'emerge, ho fatto fare il processo interamente ad emerge, e devo dire che la versione 2.2 ha gestito il problema egregiamente, non solo... ma da quello che ho visto ha rimosso le versioni bloccanti alla fine. quindi probabilmente non ci sarebbero stati nemmeno problemi a lanciara l'emerge alla cieca. è solo un'ipotesi chiaramente
_________________
Gentoo user since 2004.
"It's all fun and games, until someone loses an eye" - mom
Back to top
View user's profile Send private message
Onip
Advocate
Advocate


Joined: 02 Sep 2004
Posts: 2912
Location: Parma (Italy)

PostPosted: Sat Nov 15, 2008 4:50 pm    Post subject: Reply with quote

ckx3009 wrote:
tutto dipende se le vuoi nel world o meno. io preferisco avere tutto ben registrato in modo che se devo ricompilare con delle USE o delle CFLAGS nuove posso fare direttamente tutto senza andarmi a cercare nulla, altrimenti bestemmierei ogni santo di ogni calendario terrestre o meno.


???

Cosa c'entra ricompilare i pacchetti a piacere con il fatto che sono nel file world? Non è che se un pacchetto non è in world allora non esiste o portage "se ne scorda". Semplicemente world è fatto per dire ad emerge quali pacchetti uno vuole espressamente avere installati ( gnome, fluxbox, amarok, apache per esempio ). Al resto (cioè la gestione delle dipendenze) ci pensa il package manager ( emerge, paludis... ). Per come è pensata gentoo non ha senso mettere tutto in world o roba che non dovrebbe starci, anzi è per certi versi pure controproducente.
Se apri il world file vedrai che è solamente un elenco di atom, non contiene informazioni su USE e CFLAGS: quelle sono nella cache di portage ( /var/cache/pkg ) e ci sono per tutti i pacchetti sia quelli in world sia gli altri.
_________________
Linux Registered User n. 373835

Titus Lucretius Carus, De Rerum Natura - Tantum religio potuit suadere malorum
Back to top
View user's profile Send private message
cloc3
Advocate
Advocate


Joined: 13 Jan 2004
Posts: 4657
Location: http://www.gentoo-users.org/user/cloc3/

PostPosted: Sat Nov 15, 2008 5:00 pm    Post subject: Reply with quote

Onip wrote:
Non è che se un pacchetto non è in world allora [...] portage "se ne scorda".

in un certo senso sì.
se quel pacchetto non è dipendenza di qualche altro, non verrà aggiornato automaticamente in presenza di nuove versioni.

sono d'accordo, però con il resto dei tuoi argomenti.
aggiungere a world pacchetti superflui, che sono già dipendenza di altri, ha l'unico risultato di allungare i tempi di calcolo di emerge.
in ragione esponenziale.

regenworld --help
_________________
vu vu vu
gentù
mi piaci tu
Back to top
View user's profile Send private message
Onip
Advocate
Advocate


Joined: 02 Sep 2004
Posts: 2912
Location: Parma (Italy)

PostPosted: Sat Nov 15, 2008 5:22 pm    Post subject: Reply with quote

cloc3 wrote:

in un certo senso sì.
se quel pacchetto non è dipendenza di qualche altro, non verrà aggiornato automaticamente in presenza di nuove versioni.


se un pacchetto installato non è in world nè è dipendenza di qualcos'altro allora deve essere per forza una dipendenza morta (se si è tenuto il sistema ordinato). Che senso ha aggiornarla a questo punto? Un bel --depclean e si fanno le pulizie di primavera. :wink:

p.s. oltre all'allungarsi dei tempi di calcolo c'è anche il fatto che depclean, appunto, dopo non fa più il suo lavoro come potrebbe e quindi ci si trova con roba installata a muzzo che non è esattamente la mia idea di ordine in un sistema.

poi, chiariamo, gentoo is about choice, quindi ben venga qualunque cosa chiunque faccia sul proprio pc: si fa solo per parlare :D
_________________
Linux Registered User n. 373835

Titus Lucretius Carus, De Rerum Natura - Tantum religio potuit suadere malorum
Back to top
View user's profile Send private message
cloc3
Advocate
Advocate


Joined: 13 Jan 2004
Posts: 4657
Location: http://www.gentoo-users.org/user/cloc3/

PostPosted: Sat Nov 15, 2008 5:50 pm    Post subject: Reply with quote

Onip wrote:
Un bel --depclean e si fanno le pulizie di primavera. :wink:

:wink: ecco una cosa da non fare mai, se usi dipendenze morte.

può benissimo essere che qualcuno desideri esplicitamente conservare la versione vecchia di un dato pacchetto. ed esistono cento motivi buoni perché questo possa accadere.
se il programma è lincato staticamente, o se le librerie corrispondenti non sono soggette ad aggiornamento per chiamata di altri programmi, la cosa potrebbe risultare perfettamente stabile.

al limite, si potrebbe persino chiedere ad emerge di non scaricare gli eventuali aggiornamenti di portage per quel pacchetto.
ma sinceramente non mi ricordo più il modo.
_________________
vu vu vu
gentù
mi piaci tu
Back to top
View user's profile Send private message
Onip
Advocate
Advocate


Joined: 02 Sep 2004
Posts: 2912
Location: Parma (Italy)

PostPosted: Sat Nov 15, 2008 6:03 pm    Post subject: Reply with quote

A quel punto mascheri la versione successiva del tal pacchetto e sei a posto; al limite ti metti l'ebuild specifico in un overlay locale nel caso venga poi rimosso e ti serva ancora.
Ci sono cento buoni motivi per usare certe specifiche versioni di pacchetti, ma ci sono anche i giusti metodi che gentoo mette a disposizione, usiamo quelli piuttosto che le dipendenze morte. Se sono morte un motivo ci sarà pure :D .

Ad esempio io per matlab che necessita(va) le qt3 mi ero fatto un bell'ebuild farlocco con dentro solo RDEPEND="x11-libs/qt:3" ed ecco che emergendo quello le librerie qt venivano installate e "riconosciute" da portage come dipendenza di qualcosa. Quando l'ho rimosso depclean mi ha anche tolto le qt, perfetto nella mia personale visione di ordine ed eleganza.

Poi, lo vedo anche io, a volte ci si complica la vita per queste finezze e non a tutti sta bene, ma poi non mi si venga a dire che in gentoo le gestione delle dipendenze inverse è schifosa o che il sistema, dopo qualche anno di utilizzo, si è riempito di schifezze.

Saluti!!

p.s. @mods mi sembra che abbiamo "sforato". forse ci starebbe bene il fork()
_________________
Linux Registered User n. 373835

Titus Lucretius Carus, De Rerum Natura - Tantum religio potuit suadere malorum
Back to top
View user's profile Send private message
cloc3
Advocate
Advocate


Joined: 13 Jan 2004
Posts: 4657
Location: http://www.gentoo-users.org/user/cloc3/

PostPosted: Sat Nov 15, 2008 9:03 pm    Post subject: Reply with quote

Onip wrote:
ma ci sono anche i giusti metodi che gentoo mette a disposizione

si , ma gli strumenti di portage sono molti e non sono univoci.

per fare un esempio, se emergo strace con l'opzione -1, per evitare le versioni successive, sto utilizzando una opzione di portage.
anche se scelgo di mascherare le versioni superiori in /etc/portage utilizzo una opzione di portage.

in questo caso particolare, è probabile che la prima scelta risulti più leggera della seconda. in altri sarà il contrario o sarà indifferente.
è anche evidente che ogni scelta ha le proprie conseguenze, come la rinuncia all'uso di depclean, che tuttavia è strumento radicale e delicato, corredato da un warning molto esplicito in apertura.
Onip wrote:

p.s. @mods mi sembra che abbiamo "sforato". forse ci starebbe bene il fork()

:oops: già.
_________________
vu vu vu
gentù
mi piaci tu
Back to top
View user's profile Send private message
lordalbert
l33t
l33t


Joined: 26 Nov 2006
Posts: 832
Location: Italy

PostPosted: Sun Nov 16, 2008 1:00 pm    Post subject: Reply with quote

Un mio amico ha deciso di lasciare gentoo a causa di questo problema che gli ha sputtanato la distro.
Beh, lui è nuovo di linux, ha semplicemente cancellato i pacchetti senza rifletterci, però non mi sentirei di dargli tutti i torti. Per chi vuole avere un sistema stabile, che non presenti problemi... ricordiamoci che i problemi si hanno con pacchetti segnati come "stable", non mascherati.
Back to top
View user's profile Send private message
Onip
Advocate
Advocate


Joined: 02 Sep 2004
Posts: 2912
Location: Parma (Italy)

PostPosted: Sun Nov 16, 2008 3:09 pm    Post subject: Reply with quote

Purtroppo quando si compila da sorgenti queste cose possono capitare, non dipende sicuramente dai developer; è strutturale. Gentoo è una (meta)distribuzione che richiede attenzione, non c'è niente da fare. Ci sono altre alternative e non è un problema usarle.
_________________
Linux Registered User n. 373835

Titus Lucretius Carus, De Rerum Natura - Tantum religio potuit suadere malorum
Back to top
View user's profile Send private message
lordalbert
l33t
l33t


Joined: 26 Nov 2006
Posts: 832
Location: Italy

PostPosted: Sun Nov 16, 2008 4:43 pm    Post subject: Reply with quote

Onip wrote:
Purtroppo quando si compila da sorgenti queste cose possono capitare, non dipende sicuramente dai developer; è strutturale. Gentoo è una (meta)distribuzione che richiede attenzione, non c'è niente da fare. Ci sono altre alternative e non è un problema usarle.


Non mi sono informato più di tanto sulla questione, ma da quel che ho capito un sw è stato inglobato in un altro o qualcosa del genere... e alcuni ebuild non sono stati aggiornati a questo cambiamento.
Back to top
View user's profile Send private message
cloc3
Advocate
Advocate


Joined: 13 Jan 2004
Posts: 4657
Location: http://www.gentoo-users.org/user/cloc3/

PostPosted: Sun Nov 16, 2008 5:00 pm    Post subject: Reply with quote

lordalbert wrote:

Non mi sono informato più di tanto sulla questione,

appunto. non siamo tecnici per giudicare l'operato degli sviluppatori.
spesso l'intervento su alberi di dipendenze complessi può generare problemi di gestione, mentre una inconsistenza temporanea, che ammette comunque alcuni workaround efficaci, può essere una situazione preferibile.
questo non è certo il primo problema di dipendenze, per gentoo e non è assolutamente il più grave. pensa ad esempio i problemi con gli aggiornamenti di gcc o con l'upgrade di expat...
a mio parere, l'incidenza di questi fenomeni sta diminuendo, e le novità della nuova versione di portage offrono servizi per una gestione ancora migliore delle dipendenze. vedi ad esempio l'osservazione di Peach.

in genere, gentoo produce problemi di dipendenze prima della compilazione, le altre distribuzioni dopo.
ti assicuro che se capita di imbattersi in un problema di dipendenze con una distribuzione compilata, sono dolori molto peggiori, perché l'unica soluzione sarebbe ricompilare il software in loco, che è una contraddizione di termini.

il tuo amico ha fatto la sua scelta, ma con un motivo pretestuoso.
_________________
vu vu vu
gentù
mi piaci tu
Back to top
View user's profile Send private message
lordalbert
l33t
l33t


Joined: 26 Nov 2006
Posts: 832
Location: Italy

PostPosted: Sun Nov 16, 2008 5:17 pm    Post subject: Reply with quote

cloc3 wrote:

appunto. non siamo tecnici per giudicare l'operato degli sviluppatori.
spesso l'intervento su alberi di dipendenze complessi può generare problemi di gestione, mentre una inconsistenza temporanea, che ammette comunque alcuni workaround efficaci, può essere una situazione preferibile.


Che sia chiaro, non voglio criticare gli sviluppatori, ma dipende la definizione di "temporanea" :) Se non sbaglio è da un po che c'è il problema.
Ma a parte questo, non voglio certo fare fretta, quello che mi sono chiesto è: Non è meglio prima intervenire su pacchetti mascherati (keyword), e una volta verificato il tutto, smascherare la nuova versione?

Quote:
e le novità della nuova versione di portage offrono servizi per una gestione ancora migliore delle dipendenze. vedi ad esempio l'osservazione di Peach.


Stavo notandolo anche io. Sembrano novità alquanto interessanti.

Quote:

in genere, gentoo produce problemi di dipendenze prima della compilazione, le altre distribuzioni dopo.
ti assicuro che se capita di imbattersi in un problema di dipendenze con una distribuzione compilata, sono dolori molto peggiori, perché l'unica soluzione sarebbe ricompilare il software in loco, che è una contraddizione di termini.


Si si, quello è vero. Nei giorni scorsi ho provato debian. I driver per la mia scheda ethernet sono stati aggiunti solo nella versione .27 del kernel, quindi ho dovuto usare quel kernel compilato da me, e i problemi si sono verificati per esempio con virtualbox, in cui il pacchetto modules è stato compilato per il kernel .26 Nulla di particolare, ma ho dovuto ricompilare il pacchetto in locale. Insomma, voglio dire che i problemi si verificano un po' ovunque, però credo fosse stato più saggio prima introdurre i pacchetti mascherati, e poi, una volta verificato che non ci siano problemi, smascherarli
Back to top
View user's profile Send private message
Onip
Advocate
Advocate


Joined: 02 Sep 2004
Posts: 2912
Location: Parma (Italy)

PostPosted: Sun Nov 16, 2008 5:28 pm    Post subject: Reply with quote

lordalbert wrote:
Non è meglio prima intervenire su pacchetti mascherati (keyword), e una volta verificato il tutto, smascherare la nuova versione?


Questo è esattamente quello che i dev cercano di fare, purtroppo a volte qualche uovo va rotto comunque. Questo ne è un esempio ( 2 pacchetti separati sono stati inglobati in uno solo nuovo) e l'upgrade di expat un altro.
Daltronde se wget linka contro ad uno dei pacchetti rimossi i dev non possono intervenire più di tanto.
_________________
Linux Registered User n. 373835

Titus Lucretius Carus, De Rerum Natura - Tantum religio potuit suadere malorum
Back to top
View user's profile Send private message
ckx3009
Guru
Guru


Joined: 08 Apr 2008
Posts: 362
Location: Milano, Italy

PostPosted: Sun Nov 16, 2008 9:13 pm    Post subject: Reply with quote

riferito al penultimo post di cloc3:
io non ho mai usato l'opzione -1 nei miei emerge e tutte le volte che ho usato --depclean, non ho mai dovuto ricompilare nulla con revdep-rebuild.
probabilmente e' anche perche' guardo sempre la lista completa dei pacchetti che lui vuole eliminare, e spesso capita che alcuni li proteggo dalla rimozione perche' mi servono o mi sono comodi, come alcune versioni del kernel o 2 versioni di gcc insieme.
per quanto riguarda le librerie che hanno versioni piu' recenti di quelle richieste dai pacchetti installati, basta vedere cosa comporta l'aggiornamento: se ci sono incompatibilita' tra la libreria e il pacchetto che l'ha in dipendenza, basta mascherare nel package.mask l'aggiornamento alla libreria: nulla di anormale.
poi forse anche questo metodo avra' i suoi contro, pero' fino ad ora non ne ho trovati.

riferito a cio' che ha detto lordalbert:
c'e' anche da dire che invece di andare a prendere a testate il proprio albero di dipendenze andando a unmergere ogni pacchetto che crea conflitto, si puo' anche aspettare che qualcuno di piu' esperto parli in forum.
io personalmente ho aspettato diversi giorni avendo "emerge -uDNav world" bloccato da questo problema, pero' non sono andato a disinstallare nulla (peccato poi che mi si e' corrotto il file system e ho avuto altri problemi legati a questo, ma ho risolto).

basta avere un minimo di accortezza in quel che si fa.
Back to top
View user's profile Send private message
lordalbert
l33t
l33t


Joined: 26 Nov 2006
Posts: 832
Location: Italy

PostPosted: Sun Nov 16, 2008 9:47 pm    Post subject: Reply with quote

Onip wrote:
lordalbert wrote:
Non è meglio prima intervenire su pacchetti mascherati (keyword), e una volta verificato il tutto, smascherare la nuova versione?


Questo è esattamente quello che i dev cercano di fare, purtroppo a volte qualche uovo va rotto comunque. Questo ne è un esempio ( 2 pacchetti separati sono stati inglobati in uno solo nuovo) e l'upgrade di expat un altro.
Daltronde se wget linka contro ad uno dei pacchetti rimossi i dev non possono intervenire più di tanto.


in casi inevitabili, potrebbero inserire un messaggio di "istruzioni", che spieghi per lo meno come comportarsi.
Se uno deve prima fare il fetch, poi eliminarne 2, e poi aggiornare, non c'è nulla di male in tutto ciò! Sono cose capibili. Però se non ci fosse stato il forum io non sapevo come risolvere. Magari utenti più esperti di me non avrebbero avuto problemi, però secondo me le soluzioni sono 2. 1) Far fare tutto il lavoro a portage (quello del fetch, disinstallare, e reinstallare) 2) Mettere 2 righe in cui spiegano come comportarsi.

Forse, da quel che mi sembra di aver capito, il primo punto è stato introdotto nel nuovo portage
Back to top
View user's profile Send private message
bandreabis
Advocate
Advocate


Joined: 18 Feb 2005
Posts: 2410
Location: イタリアのロディで

PostPosted: Mon Nov 17, 2008 7:27 am    Post subject: Reply with quote

Domanda per ckx3009:

come faccio a proteggere dal emerge --depclean le diverse versioni di kernel?

Andrea
_________________
Il numero di post non fa di me un esperto! Anzi!
Back to top
View user's profile Send private message
djinnZ
Advocate
Advocate


Joined: 02 Nov 2006
Posts: 4831
Location: somewhere in L.O.S.

PostPosted: Mon Nov 17, 2008 1:15 pm    Post subject: Reply with quote

inserendole nel world come sys-kernel/vattelappesca-sources:slot o =sys-kernel/vattelappesca-sources-versione o con emerge -n =sys-kernel/vattelappesca-sources-versione.
_________________
scita et risus abundant in ore stultorum sed etiam semper severi insani sunt:wink:
mala tempora currunt...mater stultorum semper pregna est :evil:
Murpy'sLaw:If anything can go wrong, it will - O'Toole's Corollary:Murphy was an optimist :wink:
Back to top
View user's profile Send private message
bandreabis
Advocate
Advocate


Joined: 18 Feb 2005
Posts: 2410
Location: イタリアのロディで

PostPosted: Mon Nov 17, 2008 1:21 pm    Post subject: Reply with quote

djinnZ wrote:
inserendole nel world come sys-kernel/vattelappesca-sources:slot o =sys-kernel/vattelappesca-sources-versione o con emerge -n =sys-kernel/vattelappesca-sources-versione.


Sta volta sono riuscito a farmi capire... WOW. :lol:

Grazie, ero stufo di unmergere a mano dopo un
Code:
emerge --depclean -p

_________________
Il numero di post non fa di me un esperto! Anzi!
Back to top
View user's profile Send private message
ckx3009
Guru
Guru


Joined: 08 Apr 2008
Posts: 362
Location: Milano, Italy

PostPosted: Mon Nov 17, 2008 2:49 pm    Post subject: Reply with quote

Code:
# emerge --depclean

 * Always study the list of packages to be cleaned for any obvious
 * mistakes. Packages that are part of the world set will always
 * be kept.  They can be manually added to this set with
 * `emerge --noreplace <atom>`.
Back to top
View user's profile Send private message
djinnZ
Advocate
Advocate


Joined: 02 Nov 2006
Posts: 4831
Location: somewhere in L.O.S.

PostPosted: Mon Nov 17, 2008 3:25 pm    Post subject: Reply with quote

[censura] :lol:
_________________
scita et risus abundant in ore stultorum sed etiam semper severi insani sunt:wink:
mala tempora currunt...mater stultorum semper pregna est :evil:
Murpy'sLaw:If anything can go wrong, it will - O'Toole's Corollary:Murphy was an optimist :wink:
Back to top
View user's profile Send private message
bandreabis
Advocate
Advocate


Joined: 18 Feb 2005
Posts: 2410
Location: イタリアのロディで

PostPosted: Mon Nov 17, 2008 6:54 pm    Post subject: Reply with quote

[censura] :P

Oh, finalmente ho capito come utilizzare quel messaggio.
Grazie djinnZ, grazie ckx3009.
_________________
Il numero di post non fa di me un esperto! Anzi!
Back to top
View user's profile Send private message
ckx3009
Guru
Guru


Joined: 08 Apr 2008
Posts: 362
Location: Milano, Italy

PostPosted: Mon Nov 17, 2008 10:56 pm    Post subject: Reply with quote

djinnZ wrote:
[censura] :lol:

manca il :rotfl:

era solo per specificare che non mi sono inventato il comando, ma che e' scritto bello bello e chiaro chiaro, e che appare proprio quando serve :P
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Forum italiano (Italian) All times are GMT
Goto page Previous  1, 2, 3
Page 3 of 3

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum